static char rcsid[] ="$Header: errlst.c,v 820.1 86/12/04 19:53:19 root Exp $";
static char sccsid[]="%W% %Y% %Q% %G%";
char	*sys_errlist[] = {
	"Error 0",
	"Not owner",				/* 1 - EPERM */
	"No such file or directory",		/* 2 - ENOENT */
	"No such process",			/* 3 - ESRCH */
	"Interrupted system call",		/* 4 - EINTR */
	"I/O error",				/* 5 - EIO */
	"No such device or address",		/* 6 - ENXIO */
	"Arg list too long",			/* 7 - E2BIG */
	"Exec format error",			/* 8 - ENOEXEC */
	"Bad file number",			/* 9 - EBADF */
	"No children",				/* 10 - ECHILD */
	"No more processes",			/* 11 - EAGAIN */
	"Not enough core",			/* 12 - ENOMEM */
	"Permission denied",			/* 13 - EACCES */
	"Bad address",				/* 14 - EFAULT */
	"Block device required",		/* 15 - ENOTBLK */
	"Mount device busy",			/* 16 - EBUSY */
	"File exists",				/* 17 - EEXIST */
	"Cross-device link",			/* 18 - EXDEV */
	"No such device",			/* 19 - ENODEV */
	"Not a directory",			/* 20 - ENOTDIR */
	"Is a directory",			/* 21 - EISDIR */
	"Invalid argument",			/* 22 - EINVAL */
	"File table overflow",			/* 23 - ENFILE */
	"Too many open files",			/* 24 - EMFILE */
	"Not a typewriter",			/* 25 - ENOTTY */
	"Text file busy",			/* 26 - ETXTBSY */
	"File too large",			/* 27 - EFBIG */
	"No space left on device",		/* 28 - ENOSPC */
	"Illegal seek",				/* 29 - ESPIPE */
	"Read-only file system",		/* 30 - EROFS */
	"Too many links",			/* 31 - EMLINK */
	"Broken pipe",				/* 32 - EPIPE */

/* math software */
	"Argument too large",			/* 33 - EDOM */
	"Result too large",			/* 34 - ERANGE */

/* non-blocking and interrupt i/o */
	"Operation would block",		/* 35 - EWOULDBLOCK */
	"Operation now in progress",		/* 36 - EINPROGRESS */
	"Operation already in progress",	/* 37 - EALREADY */

/* ipc/network software */

	/* argument errors */
	"Socket operation on non-socket",	/* 38 - ENOTSOCK */
	"Destination address required",		/* 39 - EDESTADDRREQ */
	"Message too long",			/* 40 - EMSGSIZE */
	"Protocol wrong type for socket",	/* 41 - EPROTOTYPE */
	"Protocol not available",		/* 42 - ENOPROTOOPT */
	"Protocol not supported",		/* 43 - EPROTONOSUPPORT */
	"Socket type not supported",		/* 44 - ESOCKTNOSUPPORT */
	"Operation not supported on socket",	/* 45 - EOPNOTSUPP */
	"Protocol family not supported",	/* 46 - EPFNOSUPPORT */
	"Address family not supported by protocol family",
						/* 47 - EAFNOSUPPORT */
	"Address already in use",		/* 48 - EADDRINUSE */
	"Can't assign requested address",	/* 49 - EADDRNOTAVAIL */

	/* operational errors */
	"Network is down",			/* 50 - ENETDOWN */
	"Network is unreachable",		/* 51 - ENETUNREACH */
	"Network dropped connection on reset",	/* 52 - ENETRESET */
	"Software caused connection abort",	/* 53 - ECONNABORTED */
	"Connection reset by peer",		/* 54 - ECONNRESET */
	"No buffer space available",		/* 55 - ENOBUFS */
	"Socket is already connected",		/* 56 - EISCONN */
	"Socket is not connected",		/* 57 - ENOTCONN */
	"Can't send after socket shutdown",	/* 58 - ESHUTDOWN */
	"Too many references: can't splice",	/* 59 - ETOOMANYREFS */
	"Connection timed out",			/* 60 - ETIMEDOUT */
	"Connection refused",			/* 61 - EREFUSED */
	"Too many levels of symbolic links",	/* 62 - ELOOP */
	"File name too long",			/* 63 - ENAMETOOLONG */
	"Host is down",				/* 64 - EHOSTDOWN */
	"Host is unreachable",			/* 65 - EHOSTUNREACH */
	"Directory not empty",			/* 66 - ENOTEMPTY */
	"Too many processes",			/* 67 - EPROCLIM */
	"Too many users",			/* 68 - EUSERS */
	"Disc quota exceeded",			/* 69 - EDQUOT */

#ifdef s32
	/* reserved (by Valid) for use by Berkeley */
	"Reserved error",			/* 70 - */
	"Reserved error",			/* 71 - */
	"Reserved error",			/* 72 - */
	"Reserved error",			/* 73 - */
	"Reserved error",			/* 74 - */
	"Reserved error",			/* 75 - */
	"Reserved error",			/* 76 - */
	"Reserved error",			/* 77 - */
	"Reserved error",			/* 78 - */
	"Reserved error",			/* 79 - */
	"Reserved error",			/* 80 - */
	"Reserved error",			/* 81 - */
	"Reserved error",			/* 82 - */
	"Reserved error",			/* 83 - */
	"Reserved error",			/* 84 - */
	"Reserved error",			/* 85 - */
	"Reserved error",			/* 86 - */
	"Reserved error",			/* 87 - */
	"Reserved error",			/* 88 - */
	"Reserved error",			/* 89 - */

/* Remote Procedure Call */
	"A bug was detected in RPC",		/* 90 - ERPCBUG */
	"Insufficient local RPC resources",	/* 91 - ELOCALRESOURCE */
	"Insufficient remote RPC resources",	/* 92 - EREMOTERESOURCE */
	"Server crashed",			/* 93 - ESERVERCRASHED */
	"RPC call timed out",			/* 94 - ERPCCALLTIMEOUT */
	"Unknown local RPC class",		/* 95 - ELOCALCLASS */
	"Unknown remote RPC class",		/* 96 - EREMOTECLASS */
	"Unknown remote RPC operation",		/* 97 - EREMOTEOPERATION */

/* Extended FileSystem */
	"No more local file descriptors",	/* 98 - ENOLOCALFILE */
	"Invalid ioctl request",		/* 99 - EBADIOCTL */

/* Distributed FileSystem */
	"May not access remote socket",		/* 100 - EREMOTESOCK */
	"May not access remote block device",	/* 101 - EREMOTEBDEV */
	"Invalid inode ptr specified",		/* 102 - EBADIPTR */
	"Attempt to link across two nodes",	/* 103 - EXHOST */
	"No DFS rmt descriptor",		/* 104 - EBADRMTDESC */
	"DFS mult. host-reference in pathname",	/* 105 - EMULTIHOSTREF */
	"DFS not enabled",			/* 106 - EDFSNOTENABLED */
	"No more DFS descriptors @ remote",	/* 107 - EDFSRMTFULL */
	"Incompatibile DFS version or function",/* 108 - EDFSINCOMPATVERS */
	"DFS rmt descriptor not locked",	/* 109 - ERMTNOTLOCKED */
	"DFS told to Abort current function",	/* 110 - EDFSABORT */
#endif s32
};
int	sys_nerr = { sizeof sys_errlist/sizeof sys_errlist[0] };
